
From: Marcel Holtmann <marcel@holtmann.org>

The add_hotplug_env_var() function is available and so use it in the
firmware class code.

Signed-off-by: Marcel Holtmann <marcel@holtmann.org>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/drivers/base/firmware_class.c |   12 +++++-------
 1 files changed, 5 insertions(+), 7 deletions(-)

diff -puN drivers/base/firmware_class.c~use-add_hotplug_env_var-in-firmware-loader drivers/base/firmware_class.c
--- 25/drivers/base/firmware_class.c~use-add_hotplug_env_var-in-firmware-loader	2004-11-03 22:04:34.185535832 -0800
+++ 25-akpm/drivers/base/firmware_class.c	2004-11-03 22:04:34.188535376 -0800
@@ -94,19 +94,17 @@ firmware_class_hotplug(struct class_devi
 		       int num_envp, char *buffer, int buffer_size)
 {
 	struct firmware_priv *fw_priv = class_get_devdata(class_dev);
-	int i = 0;
-	char *scratch = buffer;
+	int i = 0, len = 0;
 
 	if (!test_bit(FW_STATUS_READY, &fw_priv->status))
 		return -ENODEV;
 
-	if (buffer_size < (FIRMWARE_NAME_MAX + 10))
-		return -ENOMEM;
-	if (num_envp < 1)
+	if (add_hotplug_env_var(envp, num_envp, &i, buffer, buffer_size, &len,
+			"FIRMWARE=%s", fw_priv->fw_id))
 		return -ENOMEM;
 
-	envp[i++] = scratch;
-	scratch += sprintf(scratch, "FIRMWARE=%s", fw_priv->fw_id) + 1;
+	envp[i++] = NULL;
+
 	return 0;
 }
 
_
